/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.33).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package it.nextworks.experiment.nbi;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.media.ArraySchema;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;
import it.nextworks.experiment.model.*;

import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.bind.annotation.CookieValue;
import org.springframework.web.bind.annotation.CrossOrigin;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2022-03-27T16:25:04.500Z[GMT]")
@Validated
public interface ElcmApi {

    @Operation(summary = "Create a new Experiment", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "201", description = "Experiment instance identifier", content = @Content(mediaType = "application/json", schema = @Schema(implementation = String.class))),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "412", description = "Precondition Failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "500", description = "Operation failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment",
        produces = { "application/json" }, 
        consumes = { "application/json" }, 
        method = RequestMethod.POST)
    ResponseEntity<String> createExperiment(@Parameter(in = ParameterIn.DEFAULT, description = "Experiment Request parameters", required=true, schema=@Schema()) @Valid @RequestBody ExperimentInstanceRequest body);


    @Operation(summary = "Requests a new experiment execution", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json", schema = @Schema(implementation = String.class))),
        
        @ApiResponse(responseCode = "201", description = "Experiment execution identifier", content = @Content(mediaType = "application/json", schema = @Schema(implementation = String.class))),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "404", description = "Not Found"),
        
        @ApiResponse(responseCode = "409", description = "Conflict. There is a running execution for the provided experiment"),
        
        @ApiResponse(responseCode = "412", description = "Precondition Failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "500", description = "Operation failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment/{id}/execution",
        produces = { "application/json", "text/plain" }, 
        consumes = { "application/json" }, 
        method = RequestMethod.POST)
    ResponseEntity<String> createExperimentExecution(@Parameter(in = ParameterIn.PATH, description = "Experiment identifier", required=true, schema=@Schema()) @PathVariable("id") String id, @Parameter(in = ParameterIn.DEFAULT, description = "Experiment Request parameters", required=true, schema=@Schema()) @Valid @RequestBody ExperimentExecutionRequest body);


    @Operation(summary = "Terminate experiment identified by experiment instance identifier", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "204", description = "Terminate Experiment from experiment instance identifier"),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "404", description = "Not Found"),
        
        @ApiResponse(responseCode = "412", description = "Precondition Failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "500", description = "Operation failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment/{id}",
        produces = { "application/json" }, 
        method = RequestMethod.DELETE)
    ResponseEntity<Void> terminateExperiment(@Parameter(in = ParameterIn.PATH, description = "Experiment Instance identifier", required=true, schema=@Schema()) @PathVariable("id") String id, @RequestParam(required = false) Boolean Force);


    @Operation(summary = "Delete experiment identified by experiment instance identifier", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "204", description = "Delete Experiment from experiment instance identifier"),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "404", description = "Not Found"),
        
        @ApiResponse(responseCode = "412", description = "Precondition Failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "500", description = "Operation failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment/{id}/delete",
        produces = { "application/json" }, 
        method = RequestMethod.DELETE)
    ResponseEntity<Void> deleteExperiment(@Parameter(in = ParameterIn.PATH, description = "Experiment Instance identifier", required=true, schema=@Schema()) @PathVariable("id") String id);


    @Operation(summary = "elcmExperimentExecutionsIdGet", description = "API to get experiment execution details", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "200", description = "Return experiment execution details", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ExperimentExecution.class))),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "404", description = "Identifier of the experiment execution not found", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "412", description = "Precondition Failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "500", description = "Operation failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment/{id}/execution/{executionId}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<ExperimentExecution> getExperimentExecution(@Parameter(in = ParameterIn.PATH, description = "id", required=true, schema=@Schema()) @PathVariable("id") String id, @Parameter(in = ParameterIn.PATH, description = "Execution id", required=true, schema=@Schema()) @PathVariable("executionId") String executionId);


    @Operation(summary = "elmcExperimentExecutionsIdAbortPost", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "204", description = "Return 204 No Content upon action completion"),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "404", description = "Identifier of the experiment execution not found", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment/{id}/execution/{executionId}/stop",
        produces = { "application/json" }, 
        method = RequestMethod.POST)
    ResponseEntity<Void> stopExperimentExecution(@Parameter(in = ParameterIn.PATH, description = "id", required=true, schema=@Schema()) @PathVariable("id") String id, @Parameter(in = ParameterIn.PATH, description = "Execution id", required=true, schema=@Schema()) @PathVariable("executionId") String executionId);


    @Operation(summary = "elmcExperimentExecutionsIdRunPost", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "204", description = "Return 204 No Content upon action completion"),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "404", description = "Identifier of the experiment execution not found", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment/{id}/execution/{executionId}/run",
        produces = { "application/json" }, 
        method = RequestMethod.POST)
    ResponseEntity<Void> runExperimentExecution(@Parameter(in = ParameterIn.PATH, description = "id", required=true, schema=@Schema()) @PathVariable("id") String id, @Parameter(in = ParameterIn.PATH, description = "Execution id", required=true, schema=@Schema()) @PathVariable("executionId") String executionId);


    @Operation(summary = "elmcExperimentExecutionsIdCompletedPost", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "204", description = "Return 204 No Content upon action completion"),

            @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),

            @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),

            @ApiResponse(responseCode = "404", description = "Identifier of the experiment execution not found", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment/{id}/execution/{executionId}/completed",
            produces = { "application/json" },
            method = RequestMethod.POST)
    ResponseEntity<Void> ExperimentExecutionCompleted(@Parameter(in = ParameterIn.PATH, description = "id", required=true, schema=@Schema()) @PathVariable("id") String id, @Parameter(in = ParameterIn.PATH, description = "Execution id", required=true, schema=@Schema()) @PathVariable("executionId") String executionId);


    @Operation(summary = "List all experiment execution available related to a single experiment instance", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "200", description = "List of all experiment executions related to a single experiment instance", content = @Content(mediaType = "application/json", array = @ArraySchema(schema = @Schema(implementation = ExperimentExecution.class)))),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "404", description = "Not Found"),
        
        @ApiResponse(responseCode = "412", description = "Precondition Failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment/{id}/execution",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<List<ExperimentExecution>> getExperimentExecutions(@Parameter(in = ParameterIn.PATH, description = "Experiment identifier", required=true, schema=@Schema()) @PathVariable("id") String id);


    @Operation(summary = "List all experiments available for execution", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "200", description = "List of all experiments", content = @Content(mediaType = "application/json", array = @ArraySchema(schema = @Schema(implementation = ExperimentLcm.class)))),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "412", description = "Precondition Failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<List<ExperimentLcm>> getExperiments(@Parameter(in = ParameterIn.QUERY, description = "Experiment instance identifier" ,schema=@Schema()) @Valid @RequestParam(value = "state", required = false) ExperimentStatus state, @Parameter(in = ParameterIn.QUERY, description = "Testbed where the experiment is running" ,schema=@Schema()) @Valid @RequestParam(value = "testbed", required = false) Testbed testbed, @Parameter(in = ParameterIn.QUERY, description = "Username that has generated the experiment" ,schema=@Schema()) @Valid @RequestParam(value = "user", required = false) String user, @Parameter(in = ParameterIn.QUERY, description = "UseCase name associated to the experiment" ,schema=@Schema()) @Valid @RequestParam(value = "usecase", required = false) String usecase, @Parameter(in = ParameterIn.QUERY, description = "Identifier of the Vertical Service instance" ,schema=@Schema()) @Valid @RequestParam(value = "verticalServiceInstanceId", required = false) String verticalServiceInstanceId);


    @Operation(summary = "Get experiment identified by experiment instance identifier", description = "", tags={ "Experiment LCM Operations" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "200", description = "Get Experiment from experiment instance identifier", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ExperimentLcm.class))),
        
        @ApiResponse(responseCode = "401", description = "Operation not authorised", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "403", description = "Operation forbidden", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "404", description = "Not Found"),
        
        @ApiResponse(responseCode = "412", description = "Precondition Failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))),
        
        @ApiResponse(responseCode = "500", description = "Operation failed", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorInfo.class))) })
    @RequestMapping(value = "/portal/elcm/experiment/{id}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    ResponseEntity<ExperimentLcm> getExperiment(@Parameter(in = ParameterIn.PATH, description = "Experiment Instance identifier", required=true, schema=@Schema()) @PathVariable("id") String id);

}

